<?php

// Function to get contact ID by email
function getContactIdByEmail($email, $apiKey) {
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://rest.gohighlevel.com/v1/contacts?query=' . urlencode($email),
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'GET',
        CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer ' . $apiKey,
            'Content-Type: application/json'
        ),
    ));
    
    $response = curl_exec($curl);
    curl_close($curl);
    $data = json_decode($response, true);
    
    if (!empty($data['contacts'])) {
        return $data['contacts'][0]['id'];
    } else {
        return null;
    }
}

// Function to update DND status
function updateDndStatus($contactId, $apiKey) {
    $curl = curl_init();
    curl_setopt_array($curl, array(
        CURLOPT_URL => 'https://rest.gohighlevel.com/v1/contacts/' . $contactId,
        CURLOPT_RETURNTRANSFER => true,
        CURLOPT_ENCODING => '',
        CURLOPT_MAXREDIRS => 10,
        CURLOPT_TIMEOUT => 0,
        CURLOPT_FOLLOWLOCATION => true,
        CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
        CURLOPT_CUSTOMREQUEST => 'PUT',
        CURLOPT_POSTFIELDS => '{
          "dndSettings": {
              "Email": {
                  "status": "active"
              }
          }
        }',
        CURLOPT_HTTPHEADER => array(
            'Authorization: Bearer ' . $apiKey,
            'Content-Type: application/json'
        ),
    ));
    
    $response = curl_exec($curl);
    curl_close($curl);
    return $response;
}

// Main script to process CSV
function processCsv($csvFilePath, $apiKey) {
    if (($handle = fopen($csvFilePath, "r")) !== FALSE) {
        while (($data = fgetcsv($handle, 10000000, ",")) !== FALSE) {
            $email = $data[0]; // Assuming email is in the first column
            echo "Processing email: $email\n";
            
            $contactId = getContactIdByEmail($email, $apiKey);
            
            if ($contactId) {
                echo "Found Contact ID: $contactId\n";
                $updateResponse = updateDndStatus($contactId, $apiKey);
                
                echo '<pre>';
                print_r($updateResponse);
                echo '</pre>';
                // echo "Update Response: " . $updateResponse . "\n";
            } else {
                echo "No contact found for email: $email\n";
            }
        }
        fclose($handle);
    } else {
        echo "Failed to open CSV file.\n";
    }
}

// Replace with your CSV file path and API key
$csvFilePath = 'CEEC.csv'; // Path to your CSV file containing the list of emails
$apiKey = 'eyJhbGciOiJIUzI1NiIsInR5cCI6IkpXVCJ9.eyJsb2NhdGlvbl9pZCI6Imp5dFNQWHQ2TmJrNTJUSnhZbDBaIiwiY29tcGFueV9pZCI6IldsMGwwWnNEZlM2RGRhNU9KdU9CIiwidmVyc2lvbiI6MSwiaWF0IjoxNzA1NzgzNzcyMzY1LCJzdWIiOiJ1c2VyX2lkIn0.0IK1kIIRGT0OJYLOoY0UK79Jr_tVtcFmPDekdMrJVEc'; // Replace with your actual API key

processCsv($csvFilePath, $apiKey);

